const u = [
  "POINT",
  "LINESTRING",
  "POLYGON",
  "MULTIPOINT",
  "MULTILINESTRING",
  "MULTIPOLYGON",
  "GEOMETRYCOLLECTION"
], d = ["ZM", "Z", "M"], o = "EMPTY";
class l {
  constructor(n) {
    this.value = n, this.position = 0;
  }
  match(n) {
    this.skipWhitespaces();
    for (const e of n)
      if (this.value.startsWith(e, this.position))
        return this.position += e.length, e;
    return null;
  }
  matchRegex(n) {
    this.skipWhitespaces();
    for (const e of n) {
      const r = this.value.substring(this.position).match(e);
      if (r)
        return this.position += r[0].length, r;
    }
    return null;
  }
  isMatch(n) {
    return this.skipWhitespaces(), this.value.startsWith(n, this.position) ? (this.position += n.length, !0) : !1;
  }
  matchType() {
    const n = this.match(u);
    if (!n)
      throw new Error("Expected geometry type");
    return n;
  }
  matchDimension() {
    switch (this.match(d)) {
      case "ZM":
        return { hasZ: !0, hasM: !0 };
      case "Z":
        return { hasZ: !0, hasM: !1 };
      case "M":
        return { hasZ: !1, hasM: !0 };
      default:
        return { hasZ: !1, hasM: !1 };
    }
  }
  expectGroupStart() {
    if (!this.isMatch("("))
      throw new Error("Expected group start");
  }
  expectGroupEnd() {
    if (!this.isMatch(")"))
      throw new Error("Expected group end");
  }
  matchCoordinate(n) {
    let e;
    if (n.hasZ && n.hasM ? e = this.matchRegex([/^(\S*)\s+(\S*)\s+(\S*)\s+([^\s,)]*)/]) : n.hasZ || n.hasM ? e = this.matchRegex([/^(\S*)\s+(\S*)\s+([^\s,)]*)/]) : e = this.matchRegex([/^(\S*)\s+([^\s,)]*)/]), !e)
      throw new Error("Expected coordinates");
    const r = n.hasZ && n.hasM ? [
      parseFloat(e[1]),
      parseFloat(e[2]),
      parseFloat(e[3]),
      parseFloat(e[4])
    ] : n.hasZ ? [parseFloat(e[1]), parseFloat(e[2]), parseFloat(e[3])] : n.hasM ? [
      parseFloat(e[1]),
      parseFloat(e[2])
    ] : [parseFloat(e[1]), parseFloat(e[2])];
    if (n.srid && n.srid !== 4326) {
      if (n.proj)
        return n.proj(`EPSG:${n.srid}`, "EPSG:4326", r);
      throw new Error(
        `EWKT data in an unknown SRID (${n.srid}) was provided, but a proj function was not`
      );
    }
    return r;
  }
  matchCoordinates(n) {
    const e = [];
    do {
      const r = this.isMatch("(");
      e.push(this.matchCoordinate(n)), r && this.expectGroupEnd();
    } while (this.isMatch(","));
    return e;
  }
  skipWhitespaces() {
    for (; this.position < this.value.length && this.value[this.position] === " "; )
      this.position++;
  }
}
const M = (t, n) => {
  if (t.isMatch(o))
    return n.emptyAsNull ? null : { type: "Point", coordinates: [] };
  t.expectGroupStart();
  const e = t.matchCoordinate(n);
  return t.expectGroupEnd(), {
    type: "Point",
    coordinates: e
  };
}, f = (t, n) => {
  if (t.isMatch(o))
    return n.emptyAsNull ? null : { type: "LineString", coordinates: [] };
  t.expectGroupStart();
  const e = t.matchCoordinates(n);
  return t.expectGroupEnd(), {
    type: "LineString",
    coordinates: e
  };
}, E = (t, n) => {
  if (t.isMatch(o))
    return n.emptyAsNull ? null : { type: "Polygon", coordinates: [] };
  const e = [];
  for (t.expectGroupStart(), t.expectGroupStart(), e.push(t.matchCoordinates(n)), t.expectGroupEnd(); t.isMatch(","); )
    t.expectGroupStart(), e.push(t.matchCoordinates(n)), t.expectGroupEnd();
  return t.expectGroupEnd(), {
    type: "Polygon",
    coordinates: e
  };
}, G = (t, n) => {
  if (t.isMatch(o))
    return n.emptyAsNull ? null : { type: "MultiPoint", coordinates: [] };
  t.expectGroupStart();
  const e = t.matchCoordinates(n);
  return t.expectGroupEnd(), {
    type: "MultiPoint",
    coordinates: e
  };
}, T = (t, n) => {
  if (t.isMatch(o))
    return n.emptyAsNull ? null : { type: "MultiLineString", coordinates: [] };
  t.expectGroupStart();
  const e = [];
  do
    t.expectGroupStart(), e.push(t.matchCoordinates(n)), t.expectGroupEnd();
  while (t.isMatch(","));
  return t.expectGroupEnd(), {
    type: "MultiLineString",
    coordinates: e
  };
}, N = (t, n) => {
  if (t.isMatch(o))
    return n.emptyAsNull ? null : { type: "MultiPolygon", coordinates: [] };
  t.expectGroupStart();
  const e = [];
  do {
    t.expectGroupStart();
    const r = [], s = [];
    for (t.expectGroupStart(), r.push.apply(r, t.matchCoordinates(n)), t.expectGroupEnd(); t.isMatch(","); )
      t.expectGroupStart(), s.push(t.matchCoordinates(n)), t.expectGroupEnd();
    e.push([r, ...s]), t.expectGroupEnd();
  } while (t.isMatch(","));
  return t.expectGroupEnd(), {
    type: "MultiPolygon",
    coordinates: e
  };
}, L = (t, n) => {
  if (t.isMatch(o))
    return n.emptyAsNull ? null : { type: "GeometryCollection", geometries: [] };
  t.expectGroupStart();
  const e = [];
  do {
    const r = p(t, n);
    r && e.push(r);
  } while (t.isMatch(","));
  return t.expectGroupEnd(), {
    type: "GeometryCollection",
    geometries: e
  };
};
function c(t) {
  return t.join(" ");
}
function a(t) {
  if (t === void 0)
    return " ";
  switch (t.length) {
    case 3:
      return " Z ";
    default:
      return " ";
  }
}
function S(t) {
  return t.coordinates.length === 0 ? "POINT EMPTY" : `POINT${a(t.coordinates)}(${c(
    t.coordinates
  )})`;
}
function m(t) {
  return t.coordinates.length === 0 ? "MULTIPOINT EMPTY" : `MULTIPOINT${a(
    t.coordinates[0]
  )}(${t.coordinates.map((n) => c(n)).join(",")})`;
}
function I(t) {
  if (t.coordinates.length === 0)
    return "LINESTRING EMPTY";
  const n = `(${t.coordinates.map((e) => c(e)).join(",")})`;
  return `LINESTRING${a(t.coordinates[0])}${n}`;
}
function g(t) {
  return t.geometries.length === 0 ? "GEOMETRYCOLLECTION EMPTY" : `GEOMETRYCOLLECTION${`(${t.geometries.map((e) => y(e)).join(",")})`}`;
}
function x(t) {
  if (t.coordinates.length === 0)
    return "MULTILINESTRING EMPTY";
  const n = `(${t.coordinates.map((e) => `(${e.map((r) => c(r))})`)})`;
  return `MULTILINESTRING${a(t.coordinates[0][0])}${n}`;
}
function O(t) {
  var e;
  if (t.coordinates.length === 0)
    return "POLYGON EMPTY";
  const n = `(${t.coordinates.map((r) => `(${r.map((s) => c(s))})`)})`;
  return `POLYGON${a((e = t.coordinates[0]) == null ? void 0 : e[0])}${n}`;
}
function P(t) {
  var e, r;
  if (t.coordinates.length === 0)
    return "MULTIPOLYGON EMPTY";
  const n = `(${t.coordinates.map((s) => `(${s.map((h) => `(${h.map((i) => c(i))})`)})`)})`;
  return `MULTIPOLYGON${a(
    (r = (e = t.coordinates[0]) == null ? void 0 : e[0]) == null ? void 0 : r[0]
  )}${n}`;
}
function p(t, n) {
  let e = null;
  const r = t.matchRegex([/^SRID=(\d+);/]);
  r && (e = parseInt(r[1], 10));
  const s = t.matchType(), h = t.matchDimension(), i = {
    ...n,
    srid: e,
    hasZ: h.hasZ,
    hasM: h.hasM
  };
  switch (s) {
    case "POINT":
      return M(t, i);
    case "LINESTRING":
      return f(t, i);
    case "POLYGON":
      return E(t, i);
    case "MULTIPOINT":
      return G(t, i);
    case "MULTILINESTRING":
      return T(t, i);
    case "MULTIPOLYGON":
      return N(t, i);
    case "GEOMETRYCOLLECTION":
      return L(t, i);
  }
}
function y(t) {
  switch (t.type) {
    case "Point":
      return S(t);
    case "LineString":
      return I(t);
    case "MultiPoint":
      return m(t);
    case "GeometryCollection":
      return g(t);
    case "Polygon":
      return O(t);
    case "MultiPolygon":
      return P(t);
    case "MultiLineString":
      return x(t);
  }
}
function C(t, n = {
  emptyAsNull: !0
}) {
  return p(new l(t), n);
}
export {
  y as geoJSONToWkt,
  C as wktToGeoJSON
};
